# Class to write CSV files, a subset of the class in shelfish.
# See also: http://en.wikipedia.org/wiki/CSV_application_support
# Uses Unicode.  For ASCII: http://billposer.org/Software/uni2ascii.html

package require TclOO

oo::class create Csv {
    method encodeLine {fields} {
        set field undefined
        set parts [list]
        set retval undefined
        foreach {field} $fields {
            set field [regsub -all {"} $field {""}]
            if {[regexp {[,\s]} $field]} {
                set field "\"$field\""
            }
            lappend parts $field
        }
        set retval [join [list [join $parts ","] "\n"] ""]
        return $retval
    }

    method formatCsv {data} {
        set line undefined
        set lines [list]
        set retval undefined
        foreach {line} $data {
            lappend lines [my encodeLine $line]
        }
        set retval [join $lines ""]
        return $retval
    }

    method formatDicts {data} {
        set item undefined
        set retval undefined
        set rows [list]
        if {[llength $data] == 0} {
            set retval ""
        } else {
            set item [lindex $data 0]
            lappend rows [dict keys $item]
            foreach {item} $data {
                lappend rows [dict values $item]
            }
            set retval [my formatCsv $rows]
        }
        return $retval
    }
}
